unit PrintReportBackwards;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ppModule, raCodMod, ppDB, DB, DBTables, ppBands, ppClass,
  ppCtrls, ppVar, ppStrtch, ppMemo, ppPrnabl, ppCache, ppProd, ppReport,
  ppComm, ppRelatv, ppDBPipe, ppDBBDE, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    dsStock: TDataSource;
    plStock: TppBDEPipeline;
    ppReport1: TppReport;
    ppStockListTitleBand1: TppTitleBand;
    ppStockListLabel24: TppLabel;
    ppStockListMemo1: TppMemo;
    ppStockListLabel21: TppLabel;
    ppStockListLabel23: TppLabel;
    ppStockListLabel22: TppLabel;
    ppStockListLabel1: TppLabel;
    ppStockListCalc2: TppSystemVariable;
    ppVariable1: TppVariable;
    ppStockListHeader: TppHeaderBand;
    ppStockListLabel31: TppLabel;
    ppStockListLabel32: TppLabel;
    ppStockListDetail: TppDetailBand;
    ppStockListLine5: TppLine;
    ppStockListLine1: TppLine;
    ppStockListDBText2: TppDBText;
    ppStockListDBText3: TppDBText;
    ppStockListDBText4: TppDBText;
    ppStockListLabel2: TppLabel;
    ppStockListLabel4: TppLabel;
    ppStockListDBText1: TppDBText;
    ppStockListLabel5: TppLabel;
    ppStockListDBText5: TppDBText;
    ppStockListLabel6: TppLabel;
    ppStockListDBText6: TppDBText;
    ppStockListDBText7: TppDBText;
    ppStockListLabel7: TppLabel;
    ppStockListLabel8: TppLabel;
    ppStockListDBText8: TppDBText;
    ppStockListLabel9: TppLabel;
    ppStockListLabel10: TppLabel;
    ppStockListDBText9: TppDBText;
    ppStockListDBText10: TppDBText;
    ppStockListLabel11: TppLabel;
    ppStockListDBText11: TppDBText;
    ppStockListLabel12: TppLabel;
    ppDBTextRcmndation: TppDBText;
    ppStockListLabel13: TppLabel;
    ppStockListDBText13: TppDBText;
    ppStockListLabel14: TppLabel;
    ppStockListDBText14: TppDBText;
    ppStockListLabel15: TppLabel;
    ppDBTextSymbol: TppDBText;
    ppStockListDBText16: TppDBText;
    ppStockListLabel17: TppLabel;
    ppStockListDBText17: TppDBText;
    ppStockListLabel18: TppLabel;
    ppStockListLabel3: TppLabel;
    ppStockListLine2: TppLine;
    ppStockListLabel16: TppLabel;
    ppStockListLine3: TppLine;
    ppStockListLabel19: TppLabel;
    ppStockListLine4: TppLine;
    ppStockListLabel20: TppLabel;
    ppStockListFooter: TppFooterBand;
    ppStockListCalc1: TppSystemVariable;
    ppStockListCalc3: TppSystemVariable;
    ppStockListSummaryBand1: TppSummaryBand;
    ppStockListLabel25: TppLabel;
    ppStockListLabel27: TppLabel;
    ppStockListLabel28: TppLabel;
    ppStockListLabel29: TppLabel;
    ppStockListLabel30: TppLabel;
    ppStockListDBCalc1: TppDBCalc;
    ppStockListLabel26: TppLabel;
    ppStockListLine7: TppLine;
    ppCalcBuyTotal: TppVariable;
    ppCalcHoldTotal: TppVariable;
    ppCalcSellTotal: TppVariable;
    ppStockListGroup1: TppGroup;
    ppStockListGroupHeaderBand1: TppGroupHeaderBand;
    ppStockListLine6: TppLine;
    ppLblRecommendation: TppLabel;
    ppStockListGroupFooterBand1: TppGroupFooterBand;
    qryStock: TQuery;
    raCodeModule1: TraCodeModule;
    procedure Button1Click(Sender: TObject);    
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  ppDevice, ppPrnDev, ppPrintr, ppTypes;

procedure TForm1.Button1Click(Sender: TObject);
var
  liIndex: Integer;
  lDevice: TppDevice;
  lPrinterDevice: TppPrinterDevice;
  lPage: TppPage;
begin

  lDevice := TppDevice.Create(nil);
  lDevice.PageSetting := psAll;
  lDevice.Publisher := ppReport1.Publisher;

  ppReport1.CachePages := True;
  ppReport1.PrintToDevices;

  lPrinterDevice := TppPrinterDevice.Create(nil);
  lPrinterDevice.Printer.PrinterSetup.Assign(ppReport1.PrinterSetup);

  lPrinterDevice.StartJob;

  for liIndex := ppReport1.Publisher.PageCount - 1 downto 0 do
    begin
      lPage := ppReport1.Publisher.Pages[liIndex];

      lPrinterDevice.ReceivePage(lPage);
    end;

  lPrinterDevice.EndJob;

  lDevice.Free;
  lPrinterDevice.Free;

end;

end.
